package thesis.jndi.provider.api;

import javax.naming.spi.InitialContextFactory;
import javax.naming.spi.ObjectFactory;
import javax.naming.spi.StateFactory;
import javax.naming.NamingException;
import java.util.Hashtable;

/*
 * Interface representing a naming or semantics provider. Implementig this interface the jndi providers
 * can plug in their own mechanism for fnding and loading factory implementations.
 * 
 * @author Elitsa Pancheva
 */
public interface Provider {
  /**
   * gets an Initial Context Factory
   */
  public InitialContextFactory getInitialContextFactory(Hashtable env) throws NamingException;

  /**
   * gets a URL Context factory for the specified schema and environment
   */
  public ObjectFactory getURLContextFactory(String schema, Hashtable env) throws NamingException;

  /**
   * returns an object factory for the given name
   */
  public ObjectFactory getObjectFactory(String name) throws NamingException;

  /**
   * returns a state factory for the given name.
   */
  public StateFactory getStateFactory(String name) throws NamingException;

}

