package thesis.jndi.provider.impl;

//import test.thesis.jndi.provider.client.TestClient;

public class ProviderManagerLauncher {
  
  static final String END_COMMAND = "shutdown";
  static final String TEST_COMMAND = "test";
  static final String INIT_PROVIDER_RESOVER = "init_resolver";
  static final String CLEAR_SCREAN_COMMAND = "cls";
  
  static final java.io.BufferedReader stdin = new java.io.BufferedReader(new java.io.InputStreamReader(System.in)); 
	
  public static void main(String[] args) {
	executeInSeparateClassloader();	
	//while(readNextCommand());
	
  }

  private static void initializeProviderResolver() {
    if (!javax.naming.spi.NamingManager.hasInitialContextFactoryBuilder()) {
      // set it for the first time
      try {
        ProviderResolver.init();
      } catch (Exception e) {
        System.out.println("Error occured while initializing ProviderResolver. Exception is : " + e.toString());
        e.printStackTrace();
      }
    }	    
  }
  
  private static boolean readNextCommand() {
    try {
      String line = stdin.readLine();
      if (line.trim().equalsIgnoreCase(END_COMMAND)) {
    	return false;
      } else if (line.trim().equalsIgnoreCase(TEST_COMMAND)) {
    	//(new TestClient()).bindTest();
    	return true;
      } else if (line.trim().equalsIgnoreCase(INIT_PROVIDER_RESOVER)) {
    	initializeProviderResolver();
    	return true;
      } else if (line.trim().equalsIgnoreCase(CLEAR_SCREAN_COMMAND)) {
    	for (int i = 0; i < 10; i++) {
		  System.out.println();
		}
    	return true;
      } else {
    	return true;
      }
    } catch (java.io.IOException e) { 
      e.printStackTrace();
      return false;
    }    
  }
  
  private static void executeInSeparateClassloader() {
	//ClassLoader testCL = new ClassLoader();
	ClassLoader threadCtxCL = Thread.currentThread().getContextClassLoader();
	System.out.println(threadCtxCL);
	
	if (threadCtxCL != null) {
	  System.out.println(threadCtxCL.getResource("test/thesis/jndi/provider/context/InitialInMemoryContextFactory.class"));
	  System.out.println(ProviderManagerLauncher.class.getClassLoader().getResource("test/thesis/jndi/provider/context/InitialInMemoryContextFactory.class"));
	}
  }
  
}
