package thesis.jndi.provider.impl.context;

import javax.naming.spi.InitialContextFactory;
import javax.naming.Context;
import javax.naming.NamingException;
import java.util.Hashtable;

/* Default InitialContextFactory implementation. This class simply returns instance of DefaultInitialContext
 *
 * @author Elitsa Pancheva
 */
public class DefaultInitialContextFactory implements InitialContextFactory {
	
  private static DefaultInitialContextFactory instance = null;

  public static InitialContextFactory getInstance() {
//    System.out.println("DefaultInitialContextFactory.getInstance");
    if (instance == null) {
      synchronized (DefaultInitialContextFactory.class) {
        if (instance == null) {
          DefaultInitialContextFactory helper = new DefaultInitialContextFactory();
          instance = helper;
        }
      }
    }
    return instance;
  }

  public Context getInitialContext(Hashtable environment) throws NamingException {
//    System.out.println("DefaultInitialContextFactory.getInitialContext");
    return new DefaultInitialContext(environment);
  }

}