package thesis.jndi.provider.impl.semantics;

import javax.naming.spi.ObjectFactory;
import javax.naming.Name;
import javax.naming.Context;
import java.util.Hashtable;

/* Default ObjectFactory Implementation : simply returns the object without making any changes.
 *
 * @author Elitsa Pancheva
 */
public class DefaultObjectFactory implements ObjectFactory {
  private Object obj;

  public DefaultObjectFactory(Object obj) {
    this.obj = obj;
  }

  public DefaultObjectFactory() {
  	this(null);
  }

  public Object getObjectInstance(Object obj, Name name, Context nameCtx, Hashtable environment) throws Exception {
    if (this.obj != null) {
      return this.obj;
	}
	return obj;
  }
}
