

import java.lang.reflect.Method;
import java.net.URL;
import java.net.URLClassLoader;

import test.thesis.jndi.provider.client.TestClient;

public class ProviderManagerLauncher {
  
  static final String END_COMMAND = "shutdown";
  static final String BIND_COMMAND = "bind";
  static final String LOOKUP_COMMAND = "lookup";
  static final String INIT_PROVIDER_RESOVER = "init_resolver";
  static final String CLEAR_SCREAN_COMMAND = "cls";
  
  static final java.io.BufferedReader stdin = new java.io.BufferedReader(new java.io.InputStreamReader(System.in)); 
	
  public static void main(String[] args) {
//	executeInSeparateClassloader();	
	while(readNextCommand());
	
  }

  private static void initializeProviderResolver() {
    if (!javax.naming.spi.NamingManager.hasInitialContextFactoryBuilder()) {
      // set it for the first time
        try {
    	  URL[] urls = new URL[] {new URL("file:/C:/develop/workspace/JNDI_Provider_Module/bin/")};
          ClassLoader cl = new URLClassLoader(urls);
          Class c = cl.loadClass("thesis.jndi.provider.impl.ProviderResolver");
          Object o = c.newInstance();
          Method init =  c.getMethod("init", null);
          init.invoke(o, null);
          System.out.println(c);
          
          System.out.println(cl);
    	
    	  if (cl != null) {
    	    System.out.println(cl.getResource("thesis/jndi/provider/impl/ProviderResolver.class"));
    	  }
      } catch (Exception e) {
        System.out.println("Error occured while initializing ProviderResolver. Exception is : " + e.toString());
        e.printStackTrace();
      }
      
    }	    
  }
  
  private static boolean readNextCommand() {
    try {
      String line = stdin.readLine();
      if (line.trim().equalsIgnoreCase(END_COMMAND)) {
    	return false;
      } else if (line.trim().equalsIgnoreCase(BIND_COMMAND)) {
    	(new TestClient()).bindTest();
    	return true;
      } else if (line.trim().equalsIgnoreCase(INIT_PROVIDER_RESOVER)) {
    	initializeProviderResolver();
    	return true;
      } else if (line.trim().equalsIgnoreCase(CLEAR_SCREAN_COMMAND)) {
    	for (int i = 0; i < 10; i++) {
		  System.out.println();
		}
    	return true;
      } else if (line.trim().equalsIgnoreCase(LOOKUP_COMMAND)) {
    	executeLookupTest();
    	return true;
      } else {
    	return true;
      }
    } catch (java.io.IOException e) { 
      e.printStackTrace();
      return false;
    }    
  }
  
  private static void executeInSeparateClassloader() {
	try {
	  URL[] urls = new URL[] {new URL("file:/C:/develop/workspace/JNDI_Provider_Module/bin/")};
      ClassLoader cl = new URLClassLoader(urls);
      Class c = cl.loadClass("thesis.jndi.provider.impl.ProviderResolver");
      Object o = c.newInstance();
      Method init =  c.getMethod("init", null);
      init.invoke(o, null);
      System.out.println(c);
      
      System.out.println(cl);
	
	  if (cl != null) {
	    System.out.println(cl.getResource("thesis/jndi/provider/impl/ProviderResolver.class"));
	  }
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
  


  private static void executeLookupTest() {
	try {
	  URL[] urls = new URL[] {new URL("file:C:/develop/workspace/JNDI_Provider_Test_Client/")};
      ClassLoader cl = new URLClassLoader(urls);
      if (cl != null) {
  	    System.out.println(cl.getResource("test/thesis/jndi/provider/client/LookupClient.class"));
  	  }
      System.out.println("current context classloader: " + Thread.currentThread().getContextClassLoader());
      Thread.currentThread().setContextClassLoader(cl);
      Class c = cl.loadClass("test.thesis.jndi.provider.client.LookupClient");
      System.out.println(c);
      Object o = c.newInstance();
      Method lookupTest =  c.getMethod("lookupTest", null);
      lookupTest.invoke(o, null);
      
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
}
