package test.thesis.jndi.provider.context;

import java.util.Hashtable;

import javax.naming.Context;
import javax.naming.NamingException;
import javax.naming.spi.InitialContextFactory;
import javax.naming.spi.ObjectFactory;
import javax.naming.spi.StateFactory;

import thesis.jndi.provider.api.Provider;

public class InMemoryContextProvider implements Provider {
  
  private static InitialContextFactory icf = new InitialInMemoryContextFactory();
  private final static String ICF_CLASS_NAME = "test.thesis.jndi.provider.context.InitialInMemoryContextFactory";
  private static ObjectFactory of = new ServiceURLContextFactory();
  
  private final static String SCHEME = "service";

  public InitialContextFactory getInitialContextFactory(Hashtable env) throws NamingException {
	String factory = (String) env.get(Context.INITIAL_CONTEXT_FACTORY);
	if (factory != null && factory.equals(ICF_CLASS_NAME)) {
	  return icf;
	}
	return null;
  }

  public ObjectFactory getObjectFactory(String name) throws NamingException {
	return null;
  }

  public StateFactory getStateFactory(String name) throws NamingException {
	return null;
  }

  public ObjectFactory getURLContextFactory(String schema, Hashtable env) throws NamingException {
	if (SCHEME.equals(schema)) {
	  return of;
	}
	return null;
  }

}
