package test.thesis.jndi.provider.semantics.book;

import java.util.Properties;

import javax.naming.NamingException;

import thesis.jndi.provider.api.ProviderManager;


public class Book {
  private String author;
  private String title;
  private String year;
  private String genre;

  public static final String AUTHOR_PROPERTY_NAME = "author";
  public static final String TITLE_PROPERTY_NAME = "title";
  public static final String YEAR_PROPERTY_NAME = "year";
  public static final String GENRE_PROPERTY_NAME = "genre";
  
  static {
	  try {
	    ProviderManager.getInstance().registerProvider(new BookProvider());
	  } catch (Throwable e) {
	    // TODO Auto-generated catch block
	    //e.printStackTrace();
	  }
  }
  
  public Book (BookInfo info) {
	Properties data = info.getProperties();  
	this.author = (String) data.get(AUTHOR_PROPERTY_NAME);
	this.title = (String) data.get(TITLE_PROPERTY_NAME);
	this.year = (String) data.get(YEAR_PROPERTY_NAME);
	this.genre = (String) data.get(GENRE_PROPERTY_NAME);
  }
  
  public BookInfo getInfo() {
	Properties info = new Properties();
	if (author != null) {
	  info.put(AUTHOR_PROPERTY_NAME, author);
	  info.put(TITLE_PROPERTY_NAME, title);
	  info.put(YEAR_PROPERTY_NAME, year);
	  info.put(GENRE_PROPERTY_NAME, genre);
	}
	return new BookInfo(info);	  
  }
}
