package test.thesis.jndi.provider.semantics.book;

import java.util.Hashtable;
import java.util.Properties;

import javax.naming.Context;
import javax.naming.Name;
import javax.naming.spi.ObjectFactory;


public class BookObjectFactory implements ObjectFactory {

	public Object getObjectInstance(Object obj, Name name, Context ctx, Hashtable env) throws Exception {
		if (obj instanceof Properties) {
		  // check if these are book info properties
		  if (((Properties) obj).get(BookInfo.BOOK_INFO_PROPERTIES) != null) {
			// create Book object based on the info
			//System.out.println("[BookObjectFactory] Create Book object based on the looked up properties");  
			return new Book(new BookInfo((Properties) obj));
		  } 
		}
		//System.out.println("[BookObjectFactory] Object: " + obj + " is not supported by this factory => return null");
		return null;
	}

}
