package test.thesis.jndi.provider.semantics.song;

import java.util.Hashtable;
import java.util.Properties;

import javax.naming.Context;
import javax.naming.Name;
import javax.naming.spi.ObjectFactory;


public class SongObjectFactory implements ObjectFactory {

	public Object getObjectInstance(Object obj, Name name, Context ctx, Hashtable env) throws Exception {
		if (obj instanceof Properties) {
		  // check if these are song info properties
		  if (((Properties) obj).get(SongInfo.SONG_INFO_PROPERTIES) != null) {
			// create Song object based on the info
			System.out.println("[SongObjectFactory] Create Song object based on the looked up properties");  
			return new Song(new SongInfo((Properties) obj));
		  } 
		}
		System.out.println("[SongObjectFactory] Object: " + obj + " is not supported by this factory => return null");
		return null;
	}

}
